<template>
   <div class="grid">
      <vue-draggable-resizable :w="270" :h="200" :x="170" :y="140" :min-height="100" :min-width="135"@dragging="onDrag" @resizing="onResize" :parent="true" :handles ="['tl', 'tr', 'br', 'bl']" :lock-aspect-ratio="true">
         <div v-for="index in grid" class="item" :key="index">
            <span :class="{'active' : index <= start}" :style="'animation-delay: '+index+'s; animation-play-state: '+playPause +';'"></span><i :style="'background: '+colorRobot+'; animation-delay: '+index+'s; animation-play-state: '+playPause +';'"></i>
         </div>
      </vue-draggable-resizable>
      <!--<p>X: {{ x }} / Y: {{ y }} - Width: {{ width }} / Height: {{ height }}</p>-->
   </div>
</template>

<script>
    import VueDraggableResizable from 'vue-draggable-resizable'
    import 'vue-draggable-resizable/dist/VueDraggableResizable.css'
    export default {
        name: "grid",
        props: [ 'steps', 'status', 'colorRobot'],
        components: {
            VueDraggableResizable
        },
        created() {
            console.log('created called.');
        },
        data: function () {
            return {
                width: 0,
                height: 0,
                x: 0,
                y: 0,
                grid: 12,
                start: '0'
            }
        },
        methods: {
            onResize: function (x, y, width, height) {
                this.x = x
                this.y = y
                this.width = width
                this.height = height
            },
            onDrag: function (x, y) {
                this.x = x
                this.y = y
            }
        },
        watch:{
            status: function(){
                if(this.status){
                    this.start = this.steps;
                } else{
                    this.steps = '0';
                }
            }
        },
        computed: {
            playPause () {
                return this.status ? 'running' : 'paused';
            }
        }
    }
</script>

<style scoped>
.grid{
   height: 480px;
   width: 600px;
   position: absolute;
}
.grid > div{
   display: flex;
   flex-wrap: wrap;
}
.grid .item{
   min-width: 25%;
   min-height: 25%;
   outline: 1px solid #888;
   display: flex;
   position: relative;
}
.grid .item span{
   background-color: rgba(3, 0, 255, .7);
   width: 0;
}
.grid .item span.active{
   animation: bounce 1s linear forwards;
}
.grid .item span.active + i{
   position: relative;
   width: 20%;
   height: 20%;
   top: 50%;
   transform: translateY(-50%);
   animation: bounceBefore 1s linear forwards;
   visibility: hidden;
}
   .draggable{
      outline: 3px solid red;
   }
@keyframes bounce {
   0% {
      width: 0;
   }
   100% {
      width: 100%;
   }
}
@keyframes bounceBefore {
   0% {
      visibility: visible;
   }
   100% {
      visibility: hidden;
      margin-right: -20%;

   }
}
</style>